Option Explicit
Option Base 1
Type complex
     real As Double
     imag As Double
End Type
'declaration des variables
Global a As Double
Global b As Double
Global m As Integer
Global n As Integer
Global nr_omeg As Integer
Global betx As Double
Global bety As Double
Global betz As Double
Global teta, fi As Single
Global p1te_c As complex
Global p2te_c As complex
Global p1tm_c As complex
Global p2tm_c As complex
Global omeg As Double
Global niur As Double
Global epsr As Double
Global index() As Integer
Global omeg_init As Double
Global omeg_fin As Double
Global a_vect() As complex
Global y1() As complex
Global y2() As complex
Global w() As Single
Global S() As complex
Global Z_par As complex
Global Z_imp As complex
Global mode As Integer
'constantes
Global Const PI = 3.14159265358978
Global Const TE = 0
Global Const TM = 1
Global Const PAR = 0
Global Const IMPAR = 1
Global Const niu0 = 4 * PI * .0000001
Global Const eps0 = .000000000008853
'variables temporaires
Global temp_d As Double
Global temp_s As Single
Global temp_i As Integer
Global temp_str As String
'variables generales
Dim Z()  As complex
Dim Z_sec() As complex
Dim col() As complex

Sub Diferenta (c As complex, a As complex, b As complex)
    c.real = a.real - b.real
    c.imag = a.imag - b.imag
End Sub

Sub Impartire (c As complex, a As complex, b As complex)
Dim r, den As Double
If Abs(b.real) > Abs(b.imag) Then
   r = b.imag / b.real
   den = b.real + r * b.imag
   c.real = (a.real + r * a.imag) / den
   c.imag = (a.imag - r * a.real) / den
Else
   r = b.real / b.imag
   den = r * b.real + b.imag
   c.real = (r * a.real + a.imag) / den
   c.imag = (r * a.imag - a.real) / den
End If
End Sub

Sub LU_descomp (a() As complex, n As Integer, indx() As Integer)
Dim i, j, k As Integer
Dim vv() As Double
Dim big, temp, dum As Double
Dim sum As complex
Dim temp_c As complex
Dim imax As Integer
ReDim vv(n) As Double
For i = 1 To n
    big = 0#
    For j = 1 To n
        temp = Modul(a(i, j))
        If temp > big Then
           big = temp
        End If
    Next j
    If big = 0# Then
       MsgBox "Erreur! Matrice nesingulaire!", 0 + 16, "Matrice S"
       Return
    End If
    vv(i) = 1# / big
Next i
For j = 1 To n
    For i = 1 To j - 1
        sum = a(i, j)
        For k = 1 To i - 1
            Call Produs(temp_c, a(i, k), a(k, j))
            Call Diferenta(sum, sum, temp_c)
        Next k
        a(i, j) = sum
    Next i
    big = 0#
    For i = j To n
       sum = a(i, j)
       For k = 1 To j - 1
            Call Produs(temp_c, a(i, k), a(k, j))
            Call Diferenta(sum, sum, temp_c)
       Next k
       a(i, j) = sum
       temp = Modul(sum) * vv(i)
       If temp > big Then
          big = temp
          imax = i
       End If
    Next i
    If j <> imax Then
    For k = 1 To n
        temp_c = a(imax, k)
        a(imax, k) = a(j, k)
        a(j, k) = temp_c
    Next k
    vv(imax) = vv(j)
    End If
    indx(j) = imax
    If j <> n Then
       sum = a(j, j)
       For i = j + 1 To n
           temp_c = a(i, j)
           Call Impartire(a(i, j), temp_c, sum)
       Next i
    End If
Next j
End Sub

Sub LU_rezolv (a() As complex, n As Integer, indx() As Integer, b() As complex)
Dim i, j, ip As Integer
Dim temp_c As complex
Dim sum As complex
For i = 1 To n
    ip = indx(i)
    sum = b(ip)
    b(ip) = b(i)
    For j = 1 To i - 1
        Call Produs(temp_c, a(i, j), b(j))
        Call Diferenta(sum, sum, temp_c)
    Next j
    b(i) = sum
Next i
For i = n To 1 Step -1
    sum = b(i)
    For j = i + 1 To n
        Call Produs(temp_c, a(i, j), b(j))
        Call Diferenta(sum, sum, temp_c)
    Next j
    Call Impartire(b(i), sum, a(i, i))
Next i
End Sub

Function Modul (a As complex) As Double
Dim x, y, temp As Double
    x = Abs(a.real)
    y = Abs(a.imag)
    If x = 0 Then
       Modul = y
    ElseIf y = 0 Then
       Modul = x
    ElseIf x > y Then
       temp = y / x
       Modul = x * Sqr(1# + temp ^ 2)
    Else
       temp = x / y
       Modul = y * Sqr(1# + temp ^ 2)
    End If
End Function

Sub P1TE (ByVal p, ByVal q As Integer)
   p = p - 1
   q = q - 1
   temp_d = (betx + 2 * q * PI / a) ^ 2 - (2 * p * PI / (a - b)) ^ 2
   If (Abs(temp_d) > 1E-20) Then
      temp_d = 1# / Sqr(a * (a - b)) * (betx + 2 * q * PI / a) * Sqr((bety ^ 2 + (2 * p * PI / (a - b)) ^ 2) / (bety ^ 2 + (betx + 2 * q * PI / a) ^ 2)) / temp_d
      p1te_c.real = Cos((betx + 2 * q * PI / a) * (a - b) / 2)
      If (p Mod 2) = 0 Then
         p1te_c.real = p1te_c.real - 1#
      Else
         p1te_c.real = p1te_c.real + 1#
      End If
      p1te_c.real = p1te_c.real * temp_d
      p1te_c.imag = -Sin((betx + 2 * q * PI / a) * (a - b) / 2) * temp_d
   Else
   End If
End Sub

Sub P1TM (ByVal p, ByVal q As Integer)
Dim tem As Double
   p = p - 1
   q = q - 1
   temp_d = (betx + 2 * q * PI / a) ^ 2 - (2 * p * PI / (a - b)) ^ 2
   If (Abs(temp_d) > 1E-20) Then
      temp_d = 1# / Sqr(a * (a - b)) / temp_d
      tem = Sqr((bety ^ 2 + ((2 * p + 1) * PI / (a - b)) ^ 2) / (bety ^ 2 + (betx + 2 * q * PI / a) ^ 2))
      p1tm_c.real = Sin((betx + 2 * q * PI / a) * (a - b) / 2) / tem * (2 * p + 1) * PI / (a - b)
      If (p Mod 2) = 0 Then
         p1tm_c.real = p1tm_c.real - (betx + 2 * q * PI / a) * tem
      Else
         p1tm_c.real = p1tm_c.real + (betx + 2 * q * PI / a) * tem
      End If
      p1tm_c.real = p1tm_c.real * temp_d
      p1tm_c.imag = Cos((betx + 2 * q * PI / a) * (a - b) / 2) * temp_d / tem * (2 * p + 1) * PI / (a - b)
   Else
   End If
End Sub

Sub P2TE (ByVal p, ByVal q As Integer)
   p = p - 1
   q = q - 1
   temp_d = (betx + 2 * q * PI / a) ^ 2 - (2 * p * PI / (a - b)) ^ 2
   If (Abs(temp_d) > 1E-20) Then
      temp_d = 1# / Sqr(a * (a - b)) * (betx + 2 * q * PI / a) * Sqr((bety ^ 2 + (2 * p * PI / (a - b)) ^ 2) / (bety ^ 2 + (betx + 2 * q * PI / a) ^ 2)) / temp_d
      p2te_c.real = -Cos(betx * a - (betx + 2 * q * PI / a) * (a + b) / 2)
      If (p Mod 2) = 0 Then
         p2te_c.real = p2te_c.real + 1#
      Else
         p2te_c.real = p2te_c.real - 1#
      End If
      p2te_c.real = p2te_c.real * temp_d
      p2te_c.imag = -Sin(betx * a - (betx + 2 * q * PI / a) * (a + b) / 2) * temp_d
   Else
   End If
End Sub

Sub P2TM (ByVal p, ByVal q As Integer)
Dim tem As Double
   p = p - 1
   q = q - 1
   temp_d = (betx + 2 * q * PI / a) ^ 2 - (2 * p * PI / (a - b)) ^ 2
   If (Abs(temp_d) > 1E-20) Then
      temp_d = 1# / Sqr(a * (a - b)) / temp_d
      tem = Sqr((bety ^ 2 + ((2 * p + 1) * PI / (a - b)) ^ 2) / (bety ^ 2 + (betx + 2 * q * PI / a) ^ 2))
      p2tm_c.real = Sin(betx * a - (betx + 2 * q * PI / a) * (a + b) / 2) / tem * (2 * p + 1) * PI / (a - b)
      If (p Mod 2) = 0 Then
         p2tm_c.real = p2tm_c.real - (betx + 2 * q * PI / a) * tem
      Else
         p2tm_c.real = p2tm_c.real + (betx + 2 * q * PI / a) * tem
      End If
      p2tm_c.real = p2tm_c.real * temp_d
      p2tm_c.imag = -Cos(betx * a - (betx + 2 * q * PI / a) * (a + b) / 2) * temp_d / tem * (2 * p + 1) * PI / (a - b)
   Else
   End If
End Sub

Sub Produs (c As complex, a As complex, b As complex)
    c.real = a.real * b.real - a.imag * b.imag
    c.imag = a.real * b.imag + a.imag * b.real
End Sub

Sub Realizeaza_A (a() As complex, n As Integer, mode As Integer)
Dim i, j, k As Integer
    If mode = TE Then
       For i = 1 To n
           Call P1TE(i, 1)
           Call P2TE(i, 1)
           Call Suma(a(i), p1te_c, p2te_c)
           a(i).imag = -a(i).imag
       Next i
    ElseIf mode = TM Then
       For i = 1 To n
           Call P1TM(i, 1)
           Call P2TM(i, 1)
           Call Suma(a(i), p1tm_c, p2tm_c)
           a(i).imag = -a(i).imag
       Next i
    Else
       MsgBox "Erreur fatale ! On quitte", 0 + 16
       End
    End If
End Sub

Sub Realizeaza_Y (y() As complex, n As Integer, m As Integer, mode As Integer, paritate As Integer)
Dim i, j, k As Integer
Dim sum As complex
Dim Ymk As complex
Dim temp_c As complex
Dim temp_c1 As complex
Dim temp_c2 As complex
Dim Gamak As complex
If mode = TE Then
   For i = 1 To n
       For j = 1 To n
           sum.real = 0#
           sum.imag = 0#
           For k = 2 To m
               temp_d = (betx + 2 * (k - 1) * PI / a) ^ 2 + bety ^ 2 - omeg ^ 2 * niu0 * niur * eps0 * epsr
               If temp_d > 0 Then
                  Gamak.real = Sqr(temp_d)
                  Gamak.imag = 0#
               Else
                  Gamak.imag = Sqr(-temp_d)
                  Gamak.real = 0#
               End If
               temp_c.real = 0#
               temp_c.imag = omeg * niu0 * niur
               Call Impartire(Ymk, Gamak, temp_c)
               Call P1TE(i, k)
               Call P2TE(i, k)
               Call Suma(temp_c1, p1te_c, p2te_c)
               Call P1TE(j, k)
               Call P2TE(j, k)
               Call Suma(temp_c2, p1te_c, p2te_c)
               temp_c2.imag = -temp_c2.imag
               Call Produs(temp_c, temp_c1, temp_c2)
               Call Produs(temp_c1, Ymk, temp_c)
               Call Suma(sum, sum, temp_c1)
           Next k
           If (i = j) And (i < m) Then
               temp_d = (2 * (i - 1) * PI / (a - b)) ^ 2 + bety ^ 2 - omeg ^ 2 * niu0 * niur * eps0 * epsr
               If temp_d > 0 Then
                  Gamak.real = Sqr(temp_d)
                  Gamak.imag = 0#
               Else
                  Gamak.imag = Sqr(-temp_d)
                  Gamak.real = 0#
               End If
               temp_c.real = 0#
               temp_c.imag = omeg * niu0 * niur
               Call Impartire(Ymk, Gamak, temp_c)
               If paritate = PAR Then
                  If temp_d > 0 Then
                     Ymk.real = Ymk.real * (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2))
                     Ymk.imag = Ymk.imag * (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2))
                  Else
                     temp_c1.real = 0#
                     temp_c1.imag = Tan(Gamak.imag * b / 2)
                     Call Produs(temp_c, Ymk, temp_c1)
                     Ymk = temp_c
                  End If
               ElseIf paritate = IMPAR Then
                  If temp_d > 0 Then
                     Ymk.real = Ymk.real * (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2))
                     Ymk.imag = Ymk.imag * (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2))
                  Else
                     temp_c1.real = 0#
                     temp_c1.imag = 1# / Tan(Gamak.imag * b / 2)
                     Call Produs(temp_c, Ymk, temp_c1)
                     Ymk = temp_c
                  End If
               Else
                  MsgBox "Erreur fatale ! On quitte", 0 + 16
                  End
               End If
               Call Suma(sum, sum, Ymk)
           End If 'i=j caz ptr impedanta a doua
           y(i, j) = sum
       Next j
   Next i
ElseIf mode = TM Then 'mod TM
   For i = 1 To n
       For j = 1 To n
           sum.real = 0#
           sum.imag = 0#
           For k = 2 To m
               temp_d = (betx + 2 * (k - 1) * PI / a) ^ 2 + bety ^ 2 - omeg ^ 2 * niu0 * niur * eps0 * epsr
               If temp_d > 0 Then
                  Gamak.real = Sqr(temp_d)
                  Gamak.imag = 0#
               Else
                  Gamak.imag = Sqr(-temp_d)
                  Gamak.real = 0#
               End If
               temp_c.real = 0#
               temp_c.imag = omeg * eps0 * epsr
               Call Impartire(Ymk, temp_c, Gamak)
               Call P1TM(i, k)
               Call P2TM(i, k)
               Call Suma(temp_c1, p1tm_c, p2tm_c)
               Call P1TM(j, k)
               Call P2TM(j, k)
               Call Suma(temp_c2, p1tm_c, p2tm_c)
               temp_c2.imag = -temp_c2.imag
               Call Produs(temp_c, temp_c1, temp_c2)
               Call Produs(temp_c1, Ymk, temp_c)
               Call Suma(sum, sum, temp_c1)
           Next k
           If (i = j) And (i < m) Then
               temp_d = ((2 * i - 1) * PI / (a - b)) ^ 2 + bety ^ 2 - omeg ^ 2 * niu0 * niur * eps0 * epsr
               If temp_d > 0 Then
                  Gamak.real = Sqr(temp_d)
                  Gamak.imag = 0#
               Else
                  Gamak.imag = Sqr(-temp_d)
                  Gamak.real = 0#
               End If
               temp_c.real = 0#
               temp_c.imag = omeg * eps0 * epsr
               Call Impartire(Ymk, temp_c, Gamak)
               If paritate = PAR Then
                  If temp_d > 0 Then
                     Ymk.real = Ymk.real * (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2))
                     Ymk.imag = Ymk.imag * (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2))
                  Else
                     temp_c1.real = 0#
                     temp_c1.imag = Tan(Gamak.imag * b / 2)
                     Call Produs(temp_c, Ymk, temp_c1)
                     Ymk = temp_c
                  End If
               ElseIf paritate = IMPAR Then
                  If temp_d > 0 Then
                     Ymk.real = Ymk.real * (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2))
                     Ymk.imag = Ymk.imag * (Exp(Gamak.real * b / 2) + Exp(-Gamak.real * b / 2)) / (Exp(Gamak.real * b / 2) - Exp(-Gamak.real * b / 2))
                  Else
                     temp_c1.real = 0#
                     temp_c1.imag = 1# / Tan(Gamak.imag * b / 2)
                     Call Produs(temp_c, Ymk, temp_c1)
                     Ymk = temp_c
                  End If
               Else
                  MsgBox "Erreur fatale ! On quitte", 0 + 16
                  End
               End If
               Call Suma(sum, sum, Ymk)
           End If 'i=j caz ptr impedanta a doua
           y(i, j) = sum
       Next j
   Next i
Else
   MsgBox "Erreur fatale ! On quitte", 0 + 16
   End
End If
End Sub

Sub Rezolva_S (Z_par As complex, Z_imp As complex, S() As complex, mode As Integer)
ReDim Z(2, 2)  As complex
ReDim Z_sec(2, 2) As complex
ReDim col(2) As complex
Dim Ym0 As Single
Dim sum As complex
Dim i, j, k As Integer
Dim temp_c As complex
    Call Suma(Z(1, 1), Z_par, Z_imp)
    Z(1, 1).real = Z(1, 1).real / 2
    Z(1, 1).imag = Z(1, 1).imag / 2
    Z(2, 2) = Z(1, 1)
    Call Diferenta(Z(1, 2), Z_par, Z_imp)
    Z(1, 2).real = Z(1, 2).real / 2
    Z(1, 2).imag = Z(1, 2).imag / 2
    Z(2, 1) = Z(1, 2)
    temp_d = Sqr(-betx ^ 2 - bety ^ 2 + omeg ^ 2 * niu0 * niur * eps0 * epsr)
    If mode = TE Then
       Ym0 = temp_d / omeg / niu0 / niur
    ElseIf mode = TM Then
       Ym0 = omeg * eps0 * epsr / temp_d
    Else
       MsgBox "Erreur fatale ! On quitte", 0 + 16
       End
    End If
    For i = 1 To 2
        For j = 1 To 2
            Z(i, j).real = Z(i, j).real * Ym0
            Z(i, j).imag = Z(i, j).imag * Ym0
            S(i, j) = Z(i, j)
        Next j
        Z(i, i).real = Z(i, i).real - 1
        S(i, i).real = S(i, i).real + 1
    Next i
    Call LU_descomp(S(), 2, index())
    For j = 1 To 2
        For i = 1 To 2
            col(i).real = 0#
            col(i).imag = 0#
        Next i
        col(j).real = 1#
        Call LU_rezolv(S(), 2, index(), col())
        For i = 1 To 2
            Z_sec(i, j) = col(i)
        Next i
    Next j
    For i = 1 To 2
        For j = 1 To 2
            sum.real = 0
            sum.imag = 0
            For k = 1 To 2
                Call Produs(temp_c, Z(i, k), Z_sec(k, j))
                Call Suma(sum, sum, temp_c)
            Next k
            S(i, j) = sum
        Next j
    Next i
End Sub

Sub Rezolva_Z (Z As complex, a() As complex, y() As complex, n As Integer)
Dim x() As complex
Dim temp_c As complex
Dim i As Integer
    ReDim x(n)
    ReDim index(n)
    For i = 1 To n
        x(i).real = a(i).real
        x(i).imag = -a(i).imag
    Next i
    Call LU_descomp(y(), n, index())
    Call LU_rezolv(y(), n, index(), x())
    Z.real = 0#
    Z.imag = 0#
    For i = 1 To n
        Call Produs(temp_c, a(i), x(i))
        Call Suma(Z, Z, temp_c)
    Next i
End Sub

Sub Suma (c As complex, a As complex, b As complex)
    c.real = a.real + b.real
    c.imag = a.imag + b.imag
End Sub

