Option Explicit
Option Base 1
Type complex
     real As Double
     imag As Double
End Type
'declaration des variables
Global a As Double
Global b As Double
Global c As Double
Global d As Double
Global e As Double
Global m As Integer
Global n As Integer
Global nr_omeg As Integer
Global betx As Double
Global bety As Double
Global betz As Double
Global teta, fi As Single
Global p_te As complex
Global p_tm As complex
Global omeg As Double
Global niur As Double
Global epsr As Double
Global index() As Integer
Global omeg_init As Double
Global omeg_fin As Double
Global a_vect_te() As complex
Global a_vect_tm() As complex
Global y_par_te() As complex
Global y_par_tm() As complex
Global y_impar_te() As complex
Global y_impar_tm() As complex
Global w() As Single
Global S_te() As complex
Global S_tm() As complex
Global Z_par_te As complex
Global Z_par_tm As complex
Global Z_imp_te As complex
Global Z_imp_tm As complex
Global mode As Integer
Global axe As Integer
Global Z_red_te() As complex
Global Z_red_tm() As complex
Global Z_te() As complex
Global Z_tm() As complex
'constantes
Global Const PI = 3.14159265358978
Global Const TE = 0
Global Const TM = 1
Global Const TOT = 2
Global Const LINI = 0
Global Const LOGA = 1
Global Const PAR = 0
Global Const IMPAR = 1
Global Const niu0 = 4 * PI * .0000001
Global Const eps0 = 8.85419E-12
'variables temporaires
'variables generales
Dim Z()  As complex
Dim Z_sec() As complex
Dim Z_prim() As complex
Dim col() As complex
'type d'analyse
Global n_modes, n_fe As Integer
Global b_val() As Double
Global fi_val() As Double
Global teta_val() As Double
Global n_val As Integer
Global nr_unghi As Integer
Global Const UNIC = 0
Global Const MULT_B = 1
Global Const MULT_UNG = 2
Global tip_analiza As Integer
Global dB As Integer
Global tip_afisare As Integer
Global tip_salvare As Integer
Global Const NIMIC = 0
Global Const S12 = 1
Global Const Z12_red = 2
Global Const Z12 = 3
Global Const Matr_Z_red = 4
Global Const Matr_Z = 5
Global Const Matr_S = 6
Global Const faza = 0
Global Const module = 1
'structure
Global struct As Integer
Global Const UNI_D = 0
Global Const BI_D = 1

Sub Diferenta (c As complex, a As complex, b As complex)
    c.real = a.real - b.real
    c.imag = a.imag - b.imag
End Sub

Sub Impartire (c As complex, a As complex, b As complex)
Dim r, den As Double
If Abs(b.real) > Abs(b.imag) Then
   r = b.imag / b.real
   den = b.real + r * b.imag
   c.real = (a.real + r * a.imag) / den
   c.imag = (a.imag - r * a.real) / den
Else
   r = b.real / b.imag
   den = r * b.real + b.imag
   c.real = (r * a.real + a.imag) / den
   c.imag = (r * a.imag - a.real) / den
End If
End Sub

Sub LU_descomp (a() As complex, n As Integer, indx() As Integer)
Dim i, j, k As Integer
Dim vv() As Double
Dim big, temp, dum As Double
Dim sum As complex
Dim temp_c As complex
Dim imax As Integer
ReDim vv(n) As Double
For i = 1 To n
    big = 0#
    For j = 1 To n
        temp = Modul(a(i, j))
        If temp > big Then
           big = temp
        End If
    Next j
    If big = 0# Then
       MsgBox "Erreur! Matrice nesingulaire!", 0 + 16, "Matrice S"
       Return
    End If
    vv(i) = 1# / big
Next i
For j = 1 To n
    For i = 1 To j - 1
        sum = a(i, j)
        For k = 1 To i - 1
            Call Produs(temp_c, a(i, k), a(k, j))
            Call Diferenta(sum, sum, temp_c)
        Next k
        a(i, j) = sum
    Next i
    big = 0#
    For i = j To n
       sum = a(i, j)
       For k = 1 To j - 1
            Call Produs(temp_c, a(i, k), a(k, j))
            Call Diferenta(sum, sum, temp_c)
       Next k
       a(i, j) = sum
       temp = Modul(sum) * vv(i)
       If temp > big Then
          big = temp
          imax = i
       End If
    Next i
    If j <> imax Then
    For k = 1 To n
        temp_c = a(imax, k)
        a(imax, k) = a(j, k)
        a(j, k) = temp_c
    Next k
    vv(imax) = vv(j)
    End If
    indx(j) = imax
    If j <> n Then
       sum = a(j, j)
       For i = j + 1 To n
           temp_c = a(i, j)
           Call Impartire(a(i, j), temp_c, sum)
       Next i
    End If
Next j
End Sub

Sub LU_rezolv (a() As complex, n As Integer, indx() As Integer, b() As complex)
Dim i, j, ip As Integer
Dim temp_c As complex
Dim sum As complex
For i = 1 To n
    ip = indx(i)
    sum = b(ip)
    b(ip) = b(i)
    For j = 1 To i - 1
        Call Produs(temp_c, a(i, j), b(j))
        Call Diferenta(sum, sum, temp_c)
    Next j
    b(i) = sum
Next i
For i = n To 1 Step -1
    sum = b(i)
    For j = i + 1 To n
        Call Produs(temp_c, a(i, j), b(j))
        Call Diferenta(sum, sum, temp_c)
    Next j
    Call Impartire(b(i), sum, a(i, i))
Next i
End Sub

Function Modul (a As complex) As Double
Dim x, y, temp As Double
    x = Abs(a.real)
    y = Abs(a.imag)
    If x = 0 Then
       Modul = y
    ElseIf y = 0 Then
       Modul = x
    ElseIf x > y Then
       temp = y / x
       Modul = x * Sqr(1# + temp ^ 2)
    Else
       temp = x / y
       Modul = y * Sqr(1# + temp ^ 2)
    End If
End Function

Sub Prod_sc (ByVal p, ByVal q As Integer, mode As Integer)
Dim d1, d2, d_dif, d_sum As Double
Dim d_s, d_c As Double
Dim coscos, sinsin, cossin, sincos As Double

   d1 = betx + 2 * q * PI / a
   d2 = p * PI / (a - b)
   d_dif = d1 - d2
   d_sum = d1 + d2
   d_s = d1 * (a - b)
   d_c = Cos(d_s)
   d_s = Sin(d_s)
If betx <> 0# Or q <> 0 Then
   If Abs(d_dif) > 1E-40 Then
      If Abs(d_sum) > 1E-40 Then
         d_sum = d_sum * d_dif
         If (p Mod 2) = 0 Then
            coscos = d_s / d_sum * d1
            cossin = (1# - d_c) / d_sum * d1
            sincos = (d_c - 1#) / d_sum * d2
            sinsin = d_s / d_sum * d2
         Else
            coscos = -d_s / d_sum * d1
            cossin = (1# + d_c) / d_sum * d1
            sincos = (-d_c - 1#) / d_sum * d2
            sinsin = -d_s / d_sum * d2
         End If
      Else
         d_sum = d_s / d_dif
         If (p Mod 2) = 0 Then
            coscos = (d_sum + a - b) / 2#
            cossin = (1# - d_c) / d_dif / 2#
            sincos = -cossin '(d_c - 1#) / d_dif / 2#
            sinsin = (d_sum - a + b) / 2#
         Else
            coscos = (a - b - d_sum) / 2#
            cossin = (1# + d_c) / d_dif / 2#
            sincos = -cossin '(-d_c - 1#) / d_dif / 2#
            sinsin = (b - d_sum - a) / 2#
         End If
      End If
   Else
      If Abs(d_sum) > 1E-40 Then
         d_dif = d_s / d_sum
         If (p Mod 2) = 0 Then
            coscos = (d_dif + a - b) / 2#
            cossin = (1# - d_c) / d_sum / 2#
            sincos = cossin '(1# - d_c) / d_sum / 2#
            sinsin = (a - b - d_dif) / 2#
         Else
            coscos = (a - b - d_dif) / 2#
            cossin = (1# + d_c) / d_dif / 2#
            sincos = cossin '(d_c + 1#) / d_dif / 2#
            sinsin = (a - b + d_dif) / 2#
         End If
      Else
         coscos = a - b
         cossin = 0#
         sincos = 0#
         sinsin = 0#
      End If
   End If
Else
   If p <> 0 Then
      If (p Mod 2) = 0 Then
         sincos = 0
      Else
         sincos = 2 * (a - b) / p / PI
      End If
      sinsin = 0
      coscos = 0
      cossin = 0
   Else
      sinsin = 0
      coscos = a - b
      cossin = 0
      sincos = 0
   End If
End If
If bety <> 0# Then
   If p = 0 Then
      If mode <> TM Then
         p_te.real = Sqr(2) * d2 * d1 * sincos - bety ^ 2 * cossin
         p_te.imag = -bety ^ 2 * coscos - d2 * d1 * sinsin * Sqr(2)
      End If
      If mode <> TE Then
         p_tm.real = d2 * d1 * coscos + bety ^ 2 * sinsin * Sqr(2)
         p_tm.imag = Sqr(2) * bety ^ 2 * sincos - d1 * d2 * cossin
      End If
   Else
      If mode <> TM Then
         p_te.real = Sqr(2) * (d2 * d1 * sincos - bety ^ 2 * cossin)
         p_te.imag = (-bety ^ 2 * coscos - d2 * d1 * sinsin) * Sqr(2)
      End If
      If mode <> TE Then
         p_tm.real = (d2 * d1 * coscos + bety ^ 2 * sinsin) * Sqr(2)
         p_tm.imag = Sqr(2) * (bety ^ 2 * sincos - d1 * d2 * cossin)
      End If
   End If
   d_sum = Sqr((bety ^ 2 + d1 ^ 2) * (bety ^ 2 + d2 ^ 2) * a * (a - b))
   If mode <> TM Then
      p_te.real = p_te.real / d_sum
      p_te.imag = p_te.imag / d_sum
   End If
   If mode <> TE Then
      If p <> 0 Then
          p_tm.real = p_tm.real / d_sum
          p_tm.imag = p_tm.imag / d_sum
      Else
          p_tm.real = 1# / Sqr(a * (bety ^ 2 + d1 ^ 2)) * d_s
          p_tm.imag = 1# / Sqr(a * (bety ^ 2 + d1 ^ 2)) * (d_c - 1)
      End If
   End If
Else
   d_sum = Sqr(a * (a - b) / 2#)
   If mode <> TM Then
      p_te.real = sincos
      p_te.imag = -sinsin
   End If
   If mode <> TE Then
      p_tm.real = coscos
      p_tm.imag = -cossin
   End If
   If mode <> TM Then
      p_te.real = p_te.real / d_sum
      p_te.imag = p_te.imag / d_sum
   End If
   If mode <> TE Then
      If p <> 0 Then
          p_tm.real = p_tm.real / d_sum
          p_tm.imag = p_tm.imag / d_sum
      Else
          If betx <> 0# Or q <> 0 Then
             p_tm.imag = 1# / Sqr(a) / d1 * (d_c - 1)
             p_tm.real = 1# / Sqr(a) / d1 * d_s
          Else
             p_tm.real = 0#
             p_tm.imag = 0#
          End If
      End If
   End If
End If
End Sub

Sub Produs (c As complex, a As complex, b As complex)
    c.real = a.real * b.real - a.imag * b.imag
    c.imag = a.real * b.imag + a.imag * b.real
End Sub

Sub Realizeaza_A (a_te() As complex, a_tm() As complex, n As Integer, mode As Integer)
Dim i, j, k As Integer
For i = 1 To n
    Call Prod_sc(i - 1, 0, mode)
    If mode <> TM Then
       a_te(i).real = p_te.real
       a_te(i).imag = -p_te.imag
    End If
    If mode <> TE Then
       a_tm(i).real = p_tm.real
       a_tm(i).imag = -p_tm.imag
    End If
Next i
End Sub

Sub Realizeaza_Y (ypar_te() As complex, yimp_te() As complex, ypar_tm() As complex, yimp_tm() As complex, n As Integer, m As Integer, mode As Integer)
Dim i, j, k As Integer
Dim sum1_te As complex
Dim sum1_tm As complex
Dim sum2_te As complex
Dim sum2_tm As complex
Dim Ymk_te, Ymk_tm As Double
Dim temp_d As Double
Dim temp_c As complex
Dim temp_c1 As complex
Dim temp_c2 As complex

   For i = 1 To n
       For j = i To n
           sum1_te.real = 0#
           sum1_te.imag = 0#
           sum2_te = sum1_te
           sum2_tm = sum1_te
           sum1_tm = sum1_te
           For k = 2 To m
               temp_d = (betx + 2 * (k - 1) * PI / a) ^ 2 + bety ^ 2 - omeg ^ 2 * niu0 * niur * eps0 * epsr
               Call Prod_sc(i - 1, k - 1, mode)
               temp_c1 = p_te
               temp_c2 = p_tm
               If i <> j Then
                  Call Prod_sc(j - 1, k - 1, mode)
               End If
               p_te.imag = -p_te.imag
               p_tm.imag = -p_tm.imag
               Call Produs(temp_c, temp_c1, p_te) 'temp_c ptr TE
               Call Produs(temp_c1, temp_c2, p_tm) 'temp_c1 ptr TM
               If temp_d > 0 Then
                  If mode <> TM Then
                     Ymk_te = -Sqr(temp_d) / omeg / niu0 / niur
                     sum2_te.real = sum2_te.real - temp_c.imag * Ymk_te
                     sum2_te.imag = sum2_te.imag + temp_c.real * Ymk_te
                  End If
                  If mode <> TE Then
                     Ymk_tm = omeg * eps0 * epsr / Sqr(temp_d)
                     sum2_tm.real = sum2_tm.real - temp_c1.imag * Ymk_tm
                     sum2_tm.imag = sum2_tm.imag + temp_c1.real * Ymk_tm
                  End If
               Else
                  If mode <> TM Then
                     Ymk_te = Sqr(-temp_d) / omeg / niu0 / niur
                     sum1_te.real = sum1_te.real + temp_c.real * Ymk_te
                     sum1_te.imag = sum1_te.imag + temp_c.imag * Ymk_te
                  End If
                  If mode <> TE Then
                     Ymk_tm = omeg * eps0 * epsr / Sqr(-temp_d)
                     sum1_tm.real = sum1_tm.real + temp_c1.real * Ymk_tm
                     sum1_tm.imag = sum1_tm.imag + temp_c1.imag * Ymk_tm
                  End If
               End If
           Next k 'calculat toata suma
           If mode <> TM Then
              ypar_te(i, j).real = sum1_te.real + sum2_te.real
              ypar_te(i, j).imag = sum1_te.imag + sum2_te.imag
              yimp_te(i, j) = ypar_te(i, j)
              If i <> j Then
                 ypar_te(j, i).real = sum1_te.real - sum2_te.real
                 ypar_te(j, i).imag = sum2_te.imag - sum1_te.imag
                 yimp_te(j, i) = ypar_te(j, i)
              End If
           End If
           If mode <> TE Then
              ypar_tm(i, j).real = sum1_tm.real + sum2_tm.real
              ypar_tm(i, j).imag = sum1_tm.imag + sum2_tm.imag
              yimp_tm(i, j) = ypar_tm(i, j)
              If i <> j Then
                 ypar_tm(j, i).real = sum1_tm.real - sum2_tm.real
                 ypar_tm(j, i).imag = sum2_tm.imag - sum1_tm.imag
                 yimp_tm(j, i) = ypar_tm(j, i)
              End If
           End If
       Next j
   Next i 's-au aflat termenii dependenti de impedanta periodica

   For i = 1 To n
       temp_d = ((i - 1) * PI / (a - b)) ^ 2 + bety ^ 2 - omeg ^ 2 * niu0 * niur * eps0 * epsr
       If temp_d > 0 Then
          temp_d = Sqr(temp_d)
          If mode <> TM Then
             Ymk_te = -temp_d / omeg / niu0 / niur
          End If
          If mode <> TE Then
            If i <> 1 Then
                Ymk_tm = omeg * eps0 * epsr / temp_d
            Else
                Ymk_tm = Sqr(eps0 * epsr / niu0 / niur)
            End If
          End If
          temp_d = (Exp(temp_d * c / 2#) - Exp(-temp_d * c / 2#)) / (Exp(temp_d * c / 2#) + Exp(-temp_d * c / 2#))
          If mode <> TM Then
             ypar_te(i, i).imag = ypar_te(i, i).imag + Ymk_te * temp_d
             yimp_te(i, i).imag = yimp_te(i, i).imag + Ymk_te / temp_d
          End If
          If mode <> TE Then
             If i <> 1 Then
                 ypar_tm(i, i).imag = ypar_tm(i, i).imag + Ymk_tm * temp_d
                 yimp_tm(i, i).imag = yimp_tm(i, i).imag + Ymk_tm / temp_d
             Else
                 ypar_tm(i, i).imag = ypar_tm(i, i).imag + Ymk_tm * Tan(omeg * Sqr(niu0 * niur * eps0 * epsr) * c / 2#)
                 yimp_tm(i, i).imag = yimp_tm(i, i).imag + Ymk_tm / Tan(omeg * Sqr(niu0 * niur * eps0 * epsr) * c / 2#)
             End If
          End If
       Else
          temp_d = Sqr(-temp_d)
          If mode <> TM Then
             Ymk_te = temp_d / omeg / niu0 / niur
          End If
          If mode <> TE Then
            If i <> 1 Then
                Ymk_tm = omeg * eps0 * epsr / temp_d
            Else
                Ymk_tm = Sqr(eps0 * epsr / niu0 / niur)
            End If
          End If
          temp_d = Tan(temp_d * c / 2#)
          If mode <> TM Then
             ypar_te(i, i).imag = ypar_te(i, i).imag + Ymk_te * temp_d
             yimp_te(i, i).imag = yimp_te(i, i).imag + Ymk_te / temp_d
          End If
          If mode <> TE Then
             If i <> 1 Then
                 ypar_tm(i, i).imag = ypar_tm(i, i).imag + Ymk_tm * temp_d
                 yimp_tm(i, i).imag = yimp_tm(i, i).imag + Ymk_tm / temp_d
             Else
                 ypar_tm(i, i).imag = ypar_tm(i, i).imag + Ymk_tm * Tan(omeg * Sqr(niu0 * niur * eps0 * epsr) * c / 2#)
                 yimp_tm(i, i).imag = yimp_tm(i, i).imag + Ymk_tm / Tan(omeg * Sqr(niu0 * niur * eps0 * epsr) * c / 2#)
             End If
          End If
       End If
   Next i 's-au aflat termenii dependenti de impedanta "metalica"
End Sub

Sub Rezolva_S (Z_par As complex, Z_imp As complex, S() As complex, Z_red() As complex, Z() As complex, mode As Integer)
ReDim Z_prim(2, 2) As complex
ReDim Z_sec(2, 2) As complex
ReDim col(2) As complex
Dim Ym0 As Single
Dim sum As complex
Dim i, j, k As Integer
Dim temp_c As complex
Dim temp_d As Double
    Call Suma(Z(1, 1), Z_par, Z_imp)
    Z(1, 1).real = Z(1, 1).real / 2
    Z(1, 1).imag = Z(1, 1).imag / 2
    Z(2, 2) = Z(1, 1)
    Call Diferenta(Z(1, 2), Z_par, Z_imp)
    Z(1, 2).real = Z(1, 2).real / 2
    Z(1, 2).imag = Z(1, 2).imag / 2
    Z(2, 1) = Z(1, 2)
    temp_d = Sqr(-betx ^ 2 - bety ^ 2 + omeg ^ 2 * niu0 * niur * eps0 * epsr)
    If mode = TE Then
       Ym0 = temp_d / omeg / niu0 / niur
    ElseIf mode = TM Then
       Ym0 = omeg * eps0 * epsr / temp_d
    Else
       MsgBox "Erreur fatale ! On quitte", 0 + 16
       End
    End If
    For i = 1 To 2
        For j = 1 To 2
            Z(i, j).real = Z(i, j).real * Ym0
            Z(i, j).imag = Z(i, j).imag * Ym0
            Z_red(i, j) = Z(i, j)
            S(i, j) = Z(i, j)
            Z_prim(i, j) = Z(i, j)
        Next j
        Z_prim(i, i).real = Z(i, i).real - 1
        S(i, i).real = S(i, i).real + 1
    Next i
    Call LU_descomp(S(), 2, index())
    For j = 1 To 2
        For i = 1 To 2
            col(i).real = 0#
            col(i).imag = 0#
        Next i
        col(j).real = 1#
        Call LU_rezolv(S(), 2, index(), col())
        For i = 1 To 2
            Z_sec(i, j) = col(i)
        Next i
    Next j
    For i = 1 To 2
        For j = 1 To 2
            sum.real = 0
            sum.imag = 0
            For k = 1 To 2
                Call Produs(temp_c, Z_prim(i, k), Z_sec(k, j))
                Call Suma(sum, sum, temp_c)
            Next k
            S(i, j) = sum
        Next j
    Next i
End Sub

Sub Rezolva_Z (Z As complex, a() As complex, y() As complex, n As Integer)
Dim x() As complex
Dim temp_c As complex
Dim i As Integer
    ReDim x(n)
    ReDim index(n)
    For i = 1 To n
        x(i).real = a(i).real
        x(i).imag = -a(i).imag
    Next i
    Call LU_descomp(y(), n, index())
    Call LU_rezolv(y(), n, index(), x())
    Z.real = 0#
    Z.imag = 0#
    For i = 1 To n
        Call Produs(temp_c, a(i), x(i))
        Call Suma(Z, Z, temp_c)
    Next i
End Sub

Sub Suma (c As complex, a As complex, b As complex)
    c.real = a.real + b.real
    c.imag = a.imag + b.imag
End Sub

